(function() {

    /**
     * Declare variables up front and define basic configuration data
     */
    var i,
        l,
        config,
        tempImage,
        animation,
        img,
        div,
        button,
        ol,
        intervalTimer,
        currentFrame = 0;
        config = {
            frames: [
                "images/frame0.png",
                "images/frame1.png",
                "images/frame2.png",
                "images/frame3.png",
                "images/frame4.png",
                "images/frame5.png",
                "images/frame6.png",
                "images/frame7.png",
                "images/frame8.png",
                "images/frame9.png",
                "images/framea.png",
                "images/frameb.png",
                "images/framec.png",
                "images/framed.png",
                "images/framee.png",
                "images/framef.png"
            ],
            interval: 62 /* in milliseconds */,
            showAllFrames: true,
            frameClassName: "frame",
            frameWidth: 200,
            frameHeight: 200,
            startText: "Start",
            stopText: "Stop"
    };
    
    /**
     * Functions that actually make stuff happen
     * 
     */
    
    function startAnimation(e) {
        var currentTime;
        button.onclick = stopAnimation;
        button.firstChild.nodeValue = config.stopText;
        currentTime = new Date();
        intervalTimer = setInterval(function() {
            currentFrame = (++currentFrame) % config.frames.length;
            animation.src = config.frames[currentFrame];
        }, config.interval);
    }
    
    function stopAnimation(e) {
        clearInterval(intervalTimer);
        button.onclick = startAnimation;
        button.firstChild.nodeValue = config.startText;
    }

    /**
     * Make the browser cache the frames by preloading
     */
    for (i = 0, l = config.frames.length; i < config.frames; i++) {
        tempImage = new Image();
        tempImage.src = config.frames[i];
    }
    
    /**
     * Set up a start/stop button
     * Use DOM0 event handling as we don't have anything complex going on
     */
    
    div = document.createElement("div");
    div.className = "controls";
    button = div.appendChild(document.createElement("button"));
    button.setAttribute("type", "button");
    button.onclick = startAnimation;
    button.appendChild(document.createTextNode(config.startText));
    document.body.appendChild(div);
    
    /**
     * Create the img element in which we'll display the animation
     *   and wrap it in div.frame to keep the DOM tidy
     */
    
    animation = document.createElement("img");
    animation.src = config.frames[0];
    animation.style.display = "block";
    div = document.createElement("div");
    div.appendChild(animation);
    div.className = config.frameClassName;
    div.style.width = config.frameWidth + "px";
    div.style.height = config.frameHeight + "px";
    document.body.appendChild(div);
    
    /**
     * Optional extra: show each frame below the animated image
     */
    
    if (config.showAllFrames) {
        ol = document.createElement("ol");
        for (i = 0, l = config.frames.length; i < l; i++) {
            ol.appendChild(document.createElement("li"));
            img = ol.lastChild.appendChild(document.createElement("img"));
            img.src = config.frames[i];
        }
        document.body.appendChild(ol, div);
    }
    
}());